****************************************************************************************************			
* Pantalla "std" 	$0c00-$23ff - SAM offset = $0c00 / $200 =  $6 = #%0000110 - valor por defecto
* buffer				$2400-3bff	- SAM offset = $2400 / $200 = $18 = #%0010010
****************************************************************************************************			
			opt 	cd
			opt	ct
			org	$4500					; donde ubicar el programa
inicio	orcc	#$50					; deshabilita interrupciones
			lda	#$5					; poner a uno los bits 0 y 2
			sta	$ff03					; para detectar FS al final de pantalla
			ldx	#$0c20				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldy	#$2420				; destino sin desplazar
			sty	destino				; guardar puntero
			ldb	#128					; blocs de 2 pixels a desplazar
			stb	<$76					; guardar en variable pagina 0
L1			lda	#192					; numero de lineas a hacer scroll
			sta	<$77					; guardar en variable pagina 0

			opt	cc
m1L		andcc	#$fe					; clear carry
			ldd	-2,x
			rolb
			rola
			std	-2,y					;  2 bytes copiados
			ldd	-4,x
			rolb
			rola
			std	-4,y					;  4 bytes copiados
			ldd	-6,x
			rolb
			rola
			std	-6,y					;  6 bytes copiados
			ldd	-8,x
			rolb
			rola
			std	-8,y					;  8 bytes copiados
			ldd	-10,x
			rolb
			rola
			std	-10,y					; 10 bytes copiados
			ldd	-12,x
			rolb
			rola
			std	-12,y					; 12 bytes copiados
			ldd	-14,x
			rolb
			rola
			std	-14,y					; 14 bytes copiados
			ldd	-16,x
			rolb
			rola
			std	-16,y					; 16 bytes copiados
			ldd	-18,x
			rolb
			rola
			std	-18,y					; 18 bytes copiados
			ldd	-20,x
			rolb
			rola
			std	-20,y					; 20 bytes copiados
			ldd	-22,x
			rolb
			rola
			std	-22,y					; 22 bytes copiados
			ldd	-24,x
			rolb
			rola
			std	-24,y					; 24 bytes copiados
			ldd	-26,x
			rolb
			rola
			std	-26,y					; 26 bytes copiados
			ldd	-28,x
			rolb
			rola
			std	-28,y					; 28 bytes copiados
			ldd	-30,x
			rolb
			rola
			std	-30,y					; 30 bytes copiados
			ldd	-32,x
			rolb
			rola
			std	-32,y					; 32 bytes copiados = 1 linea completa

									; Ahora hacemos el segundo scroll directamnete sobre el destino (no visible)
			andcc	#$fe					; clear carry
			rol	-1,y
			rol	-2,y
			rol	-3,y
			rol	-4,y
			rol	-5,y
			rol	-6,y
			rol	-7,y
			rol	-8,y
			rol	-9,y
			rol	-10,y
			rol	-11,y
			rol	-12,y
			rol	-13,y
			rol	-14,y
			rol	-15,y
			rol	-16,y
			rol	-17,y
			rol	-18,y
			rol	-19,y
			rol	-20,y
			rol	-21,y
			rol	-22,y
			rol	-23,y
			rol	-24,y
			rol	-25,y
			rol	-26,y
			rol	-27,y
			rol	-28,y
			rol	-29,y
			rol	-30,y
			rol	-31,y
			rol	-32,y					; 32 bytes movidos = 1 linea completa

			ldb	<$77
			cmpb	#96
			lblo	noMas
									; Ahora hacemos el TERCER scroll directamente sobre el destino (no visible)
			andcc	#$fe					; clear carry
			rol	-1,y
			rol	-2,y
			rol	-3,y
			rol	-4,y
			rol	-5,y
			rol	-6,y
			rol	-7,y
			rol	-8,y
			rol	-9,y
			rol	-10,y
			rol	-11,y
			rol	-12,y
			rol	-13,y
			rol	-14,y
			rol	-15,y
			rol	-16,y
			rol	-17,y
			rol	-18,y
			rol	-19,y
			rol	-20,y
			rol	-21,y
			rol	-22,y
			rol	-23,y
			rol	-24,y
			rol	-25,y
			rol	-26,y
			rol	-27,y
			rol	-28,y
			rol	-29,y
			rol	-30,y
			rol	-31,y
			rol	-32,y					; 32 bytes movidos = 1 linea completa

									; Ahora hacemos el CUARTO scroll directamente sobre el destino (no visible)
			andcc	#$fe					; clear carry
			rol	-1,y
			rol	-2,y
			rol	-3,y
			rol	-4,y
			rol	-5,y
			rol	-6,y
			rol	-7,y
			rol	-8,y
			rol	-9,y
			rol	-10,y
			rol	-11,y
			rol	-12,y
			rol	-13,y
			rol	-14,y
			rol	-15,y
			rol	-16,y
			rol	-17,y
			rol	-18,y
			rol	-19,y
			rol	-20,y
			rol	-21,y
			rol	-22,y
			rol	-23,y
			rol	-24,y
			rol	-25,y
			rol	-26,y
			rol	-27,y
			rol	-28,y
			rol	-29,y
			rol	-30,y
			rol	-31,y
			rol	-32,y					; 32 bytes movidos = 1 linea completa

noMas		leax	32,x					; ready for next line
			leay	32,y					; ready for next line
			dec 	<$77					; movidas todas las lneas?
			lbne	m1L					; no, hacer siguiente lnea

			opt	cc
eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
			lda	$ff02					; limpiar indicador de interrupcin
			sync

											; cambiar inicio de pantalla en SAM
cambio	lda	<$76					; lee contador numero de scrolls a realizar
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffcb					; 1
			sta	$ffce					; 0 = #%0000110 = 6 (valor x defecto)
			bra	actPun				; salta codigo para Pares
par		sta	$ffca					; 0
			sta	$ffcf					; 1 = #%0010010 = 18 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	<$76					; movida la imagen completa?
			lbne	L1						; no, siguiente pixel abajo

			opt	cc
			andcc	#$af					; habilita interrupciones
			rts							; retorna
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
			end 	inicio
