****************************************************************************************************			
* Pantalla "std" 	$0c00-$23ff - SAM offset = $0c00 / $200 =  $6 = #%0000110 - valor por defecto
* buffer				$2400-3bff	- SAM offset = $2400 / $200 = $18 = #%0010010
****************************************************************************************************			
			opt	cd
			opt	ct
			org	$4500					; donde ubicar el programa
inicio	orcc	#$50					; deshabilita interrupciones
			lda	#$5					; poner a uno los bits 0 y 2
			sta	$ff03					; para detectar FS al final de pantalla
			ldx	#$0c00				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldy	#$2400				; destino sin desplazar
			sty	destino				; guardar puntero
			ldb	#128					; blocs de 2 pixels a desplazar
			stb	<$76					; guardar en variable pagina 0
L1			lda	#192					; numero de lineas a hacer scroll
			sta	<$77					; guardar en variable pagina 0

			opt	cc
m1L		andcc	#$fe					; clear carry
			ldd	,x
			rora
			rorb
			std	,y						;  2 bytes copiados
			ldd	2,x
			rora
			rorb
			std	2,y					;  4 bytes copiados
			ldd	4,x
			rora
			rorb
			std	4,y					;  6 bytes copiados
			ldd	6,x
			rora
			rorb
			std	6,y					;  8 bytes copiados
			ldd	8,x
			rora
			rorb
			std	8,y					; 10 bytes copiados
			ldd	10,x
			rora
			rorb
			std	10,y					; 12 bytes copiados
			ldd	12,x
			rora
			rorb
			std	12,y					; 14 bytes copiados
			ldd	14,x
			rora
			rorb
			std	14,y					; 16 bytes copiados
			ldd	16,x
			rora
			rorb
			std	16,y					; 18 bytes copiados
			ldd	18,x
			rora
			rorb
			std	18,y					; 20 bytes copiados
			ldd	20,x
			rora
			rorb
			std	20,y					; 22 bytes copiados
			ldd	22,x
			rora
			rorb
			std	22,y					; 24 bytes copiados
			ldd	24,x
			rora
			rorb
			std	24,y					; 26 bytes copiados
			ldd	26,x
			rora
			rorb
			std	26,y					; 28 bytes copiados
			ldd	28,x
			rora
			rorb
			std	28,y					; 30 bytes copiados
			ldd	30,x
			rora
			rorb
			std	30,y					; 32 bytes copiados = 1 linea completa
			andcc	#$fe					; clear carry
			ror	,y
			ror	1,y
			ror	2,y
			ror	3,y
			ror	4,y
			ror	5,y
			ror	6,y
			ror	7,y
			ror	8,y
			ror	9,y
			ror	10,y
			ror	11,y
			ror	12,y
			ror	13,y
			ror	14,y
			ror	15,y
			ror	16,y
			ror	17,y
			ror	18,y
			ror	19,y
			ror	20,y
			ror	21,y
			ror	22,y
			ror	23,y
			ror	24,y
			ror	25,y
			ror	26,y
			ror	27,y
			ror	28,y
			ror	29,y
			ror	30,y
			ror	31,y					; 32 bytes movidos = 1 linea completa
											; aadir 2 bits del ULTIMO byte de ORIGEN al PRIMER byte DESTINO
			lda	31,x					; toma ultimo byte de origen
			clrb							; borra byte de trabajo
			rora
			rorb							; le pasa 1 bit
			rora
			rorb							; le ha pasado dos bits
			orb	,y
			stb	,y						; pone los dos bits movidos (circular)
			leax	32,x
			leay	32,y
			dec 	<$77					; movidas todas las lneas?
			lbne	m1L					; no, hacer siguiente lnea

			opt	cc
eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
			lda	$ff02					; limpiar indicador de interrupcin
			sync							; cambiar inicio de pantalla en SAM
cambio	lda	<$76					; lee contador numero de scrolls a realizar
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffcb					; 1
			sta	$ffce					; 0 = #%0000110 = 6 (valor x defecto)
			bra	actPun				; salta codigo para Pares
par		sta	$ffca					; 0
			sta	$ffcf					; 1 = #%0010010 = 18 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	<$76					; movida la imagen completa?
			lbne	L1						; no, siguiente pixel abajo

			opt	cc
			andcc	#$af					; habilita interrupciones
			rts							; retorna
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
			end 	inicio
